/*	Justin Fiedler
	main.cpp
	The main file creates a window with an image of the Hoff, a slider and a save button.
	The slider creates a border around the image dependant on the slider value.
*/

#include <iostream>
using namespace std;

#pragma warning (push)			//hide all the Fltk warnings
#pragma warning(disable : 4204)
#pragma warning(disable : 4244)
#pragma warning(disable : 4312)
#pragma warning(disable : 4311)
#pragma warning(disable : 4083)
#pragma warning(disable : 4193)
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Button.H>
#include <FL/fl_draw.h>
#pragma warning (pop)			//turn warnings back on

#include "TargaImage.h"
#include "MyImage.h"

Fl_Window*       win = NULL;     // The main window pointer
MyImage*		 image = NULL;	 // image pointer
Fl_Button*       button = NULL;  // The save button pointer
Fl_Value_Slider* slider = NULL;  // The pointer to border size slider
int border_size = 0;			 // the border size as a global cause I'm lazy


// * The slider callback function
void Slider_Callback(Fl_Widget *w){
	//change border size to slider value
	border_size = slider->value();
	image->border(border_size);
	image->damage(1);
}

// * The button callback function
void Button_Callback(Fl_Widget *w){
	//save the final image	
	image->image->Save_Image("border.tga");
}

int main(int argc, char** args){
	// Set up the container window
	win = new Fl_Window(300, 300, "Example Window");
		//image
		image = new MyImage(0, 0, 250, 250);
		
		//border size slider
		slider = new Fl_Value_Slider(5, 270, 200, 25);
		slider->type(FL_HOR_SLIDER);
		slider->bounds(0.0, 75.0);
		slider->value(0.0);
		slider->callback(Slider_Callback);
		slider->show();

		//save button
		button = new Fl_Button(220, 270, 75, 25, "Save");
		button->callback(Button_Callback);
	win->end();
	win->show();
	return Fl::run();

}
